﻿var delightcrmemailreply = {
  onLoad: function() {
    // initialization code
    this.initialized = true;
    this.strings = document.getElementById("delightcrmemailreply-strings");
    document.getElementById("threadPaneContext")	
            .addEventListener("popupshowing", function(e) { this.showContextMenu(e); }, false);
  },

  showContextMenu: function(event) {
    // show or hide the menuitem based on what the context menu is on
    // see http://kb.mozillazine.org/Adding_items_to_menus
    document.getElementById("context-delightcrmemailreply").hidden = (GetNumSelectedMessages() > 0);
  },
  onMenuItemCommand: function(e) {		
		//delightcrmemailreply.SendMailToCRM(e);
  },
  onToolbarButtonCommand: function(AAction) {
    // just reuse the function above.  you can change this, obviously!
    delightcrmemailreply.SendMailToCRM(AAction);
  },

ShowAlert: function(Title, Msg) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, Title, Msg);
},

getMessageRAWData: function(aMessageHeader)  
   {     
    var messenger = Components.classes["@mozilla.org/messenger;1"].createInstance(Components.interfaces.nsIMessenger);   
    var msgUri = aMessageHeader.folder.getUriForMsg(aMessageHeader);  	 
				
		var rawMessage = '';
		var  msgService = messenger.messageServiceFromURI(msgUri);
		var  msgHeader = msgService.messageURIToMsgHdr(msgUri);
		var  msgStream = Components.classes["@mozilla.org/network/sync-stream-listener;1"].createInstance();
		var  inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance().QueryInterface(Components.interfaces.nsIScriptableInputStream);

		inputStream.init(msgStream);
 
		msgService.streamMessage(msgUri, msgStream, msgWindow, null, false, null);
		inputStream.available();
		while (inputStream.available()) rawMessage = rawMessage + inputStream.read(1024);
 
    return rawMessage;	 		
			
},

SendMailToCRM: function(AAction) {
	try {	  	    
		//  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");			
		
		CRMClass = Components.classes["@delightsoftware.com/crmservice;1"];				
	    if (CRMClass == undefined) { // Thunderbird <= 3.x compatibility
			CRMClass = Components.classes["delightcrm@delightsoftware.com/crmservice;1"];
		}
		obj = CRMClass.createInstance();			
		obj = obj.QueryInterface(Components.interfaces.IDelightCRMServices);		
	} catch (err) {
		alert(err);
		return;
	}
	
	
	try {
	  //var res = obj.SendMailToCRM();
		var res = 0;
		//delightcrmemailreply.ShowAlert(gFolderDisplay.displayedFolder.name);
		
    // https://developer.mozilla.org/en/Extensions/Thunderbird/HowTos/Common_Thunderbird_Use_Cases/Open_Folder#Select_Messages		
    // https://developer.mozilla.org/en/NsIMsgDBHdr
		// http://www.fstoffel.de/tbblog/2009/04/11/how-to-get-a-message-body/
		// http://mxr.mozilla.org/comm-central/source/mozilla/xpcom/io/nsIInputStream.idl
		// http://mxr.mozilla.org/comm-central/source/mailnews/base/public/nsIMsgMessageService.idl
		
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    	var ClientPath = prefs.getCharPref("extensions.delightcrmemailreply.crmclientpath");
		var BIUsername = prefs.getCharPref("extensions.delightcrmemailreply.crmusername");
		var BIPassword = prefs.getCharPref("extensions.delightcrmemailreply.crmpassword");
		
		for (var i = 0; i < gFolderDisplay.selectedCount; i++) {
		    var Msg = gFolderDisplay.selectedMessages[i];
			var MsgStr = delightcrmemailreply.getMessageRAWData(Msg);			
				
			try {
			  // try to decode UTF8 else we have bad Umlauts äöü in plaintext only mails
			  //MsgStr = decodeURIComponent(escape(MsgStr));
			} catch(err) { }
			
			//alert(gFolderDisplay.displayedFolder.displayRecipients);			
			
			if (gFolderDisplay.displayedFolder.displayRecipients == true) {
				if (AAction == 2) { //eemArchiveMail
					AAction = 3; // eemArchiveSentMail 
				} else {
					delightcrmemailreply.ShowAlert("delight error", "Gesendete Objekte können nur archiviert und nicht beantwortet werden!");
					return;	
				}
			} else {
				// keep current action
			}
			
			// long SendMailToCRM(in ACString AEmailRAWData, in long AActionIndex, in AString AEmailAddress, in AString ASenderName, in AString AClientPath, in AString AUsername, in AString APassword, in AString AFileDisplayName, in PRTime AFileDate);

			if (AAction == 3) { // eemArchiveSentMail
			  var AuthorEmail = Msg.mime2DecodedRecipients.replace(/^.*</, "").replace(/>$/, "");
			  var AuthorName = Msg.mime2DecodedRecipients.replace(/(?= <).*/, "");			
			} else {
			  var AuthorEmail = Msg.mime2DecodedAuthor.replace(/^.*</, "").replace(/>$/, "");
			  var AuthorName = Msg.mime2DecodedAuthor.replace(/(?= <).*/, "");
			}
			  
			//delightcrmemailreply.ShowAlert(AuthorEmail + " " + AuthorName);
			
			res = obj.SendMailToCRM(MsgStr, AAction, AuthorEmail, AuthorName, ClientPath, BIUsername, BIPassword, Msg.mime2DecodedSubject + ".eml", Msg.date);	
			
			if (i == gFolderDisplay.selectedCount-1) {
				if (res == 1) {
					delightcrmemailreply.ShowAlert("delight error", "Es ist ein unbekanntes Problem bei der Übergabe aufgetreten!");
				} else {
				  if (res == 0) {
					delightcrmemailreply.ShowAlert("delight notify", "Email wurde erfolgreich an ihr delight-Programm übertragen.");
				  }
				}
			}
		}
		
	} catch (err) {
		alert(err);
		return;
	}	
}


	
};
window.addEventListener("load", function(e) { delightcrmemailreply.onLoad(e); }, false);
